--Seccion para cargar las librerias requeridas------

local sti = require "STI" --La libreria STI (Simple Tile Loader) ayuda a dibujar el mapa de fondo
Class = require "class"  --La libreria Class de HUMP ayuda a obtener un acercamiento a objetos en el programa
Timer  = require "timer"  -- La libreria Timer de HUMP ayuda a realizar funciones de manera cronometrada
require "TEsound"  		  --La libreria TESound ayuda a manejar la musica/sfx de manera sencilla

-----------------------------------------------------

---Seccion que carga todos los recursos que va a utilizar el programa-------
function love.load(arg)

    if arg[#arg] == "-debug" then require("mobdebug").start() end
    local scaleX = 1
    local scaleY = 1

    lifebar = {}
    lifebar[1] = love.graphics.newImage ("life1.png")
    lifebar[2] = love.graphics.newImage ("life2.png")
    lifebar[3] = love.graphics.newImage ("life3.png")

    arnulfo = {}
    arnulfo[1] = love.graphics.newImage ("j1.png")
    arnulfo[2] = love.graphics.newImage ("j1d.png")



	mapa = sti.new("buttonBashers")
	p1Counter = 0
	p2Counter = 0
	p1Vidas = 3
	p2Vidas = 3
	contador = 0

	logo = love.graphics.newImage ("logo.png")
	bgm = love.audio.newSource("bgm.mp3")
	hit = love.audio.newSource("hit.wav",static)
	hurt = love.audio.newSource("hurt.wav",static)


	gamestate = "menu" -- Menu, Pelea ,Calcula, GameOver (Con ganador)



	font = love.graphics.newImageFont("font.png",
	" abcdefghijklmnopqrstuvwxyz" ..
	"ABCDEFGHIJKLMNOPQRSTUVWXYZ0" ..
	"123456789.,!?-+/():;%&`'*#=[]\"")

	contador = love.graphics.newFont("Oswald-Regular.ttf",30)



	love.graphics.setFont(font)
	love.graphics.setColor(255,255,255)
	love.graphics.setBackgroundColor(255,255,255)

	Luchador  = Class{                            --Clase que define a los jugadores
		init = function(self,playerNumber,vidas)  --Constructor
			self.playerNumber = playerNumber
			self.vidas = vidas
		end;
		--funciones
		stats = function(self)
			if self.vidas > 0 then
				return string.format("Hola, soy el jugador #%.02f, y actualmente tengo %.02f vidas.",self.playerNumber,self.vidas)
			elseif self.vidas == 0 then
				return string.format("Hola, soy el jugador #%.02f, y actualmente estoy muerto!",self.playerNumber)
			end
		end;
		setVidas = function(self,vidas)
			self.vidas = vidas
		end;
		getVidas = function(self)
			return  self.vidas
		end;
	}

end
---------------------------------------------------------------------------------------------

----Funcion que nos dice que va a pasar cuando se cambie de frame--------------------
function love.update(dt)
	if gamestate == "menu" then
	end
	if gamestate == "pelea" then
		checaVidas(p1Vidas,p2Vidas)
		if turnoTermino == true then
		end

		if pelea == true then
			love.keypressed()
		end
	end
	if gamestate == "gameOver" then
		love.keypressed()
	end
	if gamestate == "Calcula" then
		love.keypressed()
		checaVidas(p1Vidas,p2Vidas)
	end



	Timer.update(dt)  --Funcion necesaria para que todas las funciones que usen Timer se ejecuten
	mapa:update(dt)   --Funcion para dibujar el mapa en cada cuadro
	TEsound.cleanup() --Funcion para que TEsound funcione adecuadamente

end
--------------------------------------------------------------------------------------------------


function love.draw()
	if gamestate == "pelea" then
		Jugador1=Luchador(1,p1Vidas)
		Jugador2=Luchador(2,p2Vidas)
		mapa:draw(scaleX,scaleY)
		dibujaGUI()
		Timer.add(1, function() peleense() end)

	elseif gamestate == "menu" then	
		love.graphics.draw(logo,120,0,0,1,1)
		love.graphics.print("Apachurra ESPACIO para INICIAR!",160,370)


	elseif gamestate == "GameOver" then
		mapa:draw(scaleX,scaleY)
		love.graphics.setFont(contador,30)
		love.graphics.print ("GAME OVER",260,80)
		love.graphics.print ("Ganador: ",220,130)
		love.graphics.print (ganador,350,130)
	elseif gamestate == "Resultados"
		mapa:draw(scaleX,scaleY)
		dibujaGUI()

	end
end




------FUNCIONES DEL PROGRAMA-------------




function love.keypressed(key) -- Funcion que
	if gamestate == "pelea"  then
		bgm:play()


	   	if key == "z" then
	    p1Counter = p1Counter + 1
	    TEsound.play("hit.wav",sfx,0.3)
	   elseif key == "m" then
	   		p2Counter = p2Counter + 1
	   		TEsound.play("hit.wav",sfx,0.3)
	   elseif key == "o" then
	   		if p1Vidas > 0 then
	   			p1Vidas = p1Vidas - 1
	   			TEsound.play("hurt.wav",sfx,0.3)
	   			Jugador1:setVidas(p1Vidas)
	   		end
	   elseif key == "p" then
	   		if p2Vidas > 0 then
	   			p2Vidas = p2Vidas - 1
	   			TEsound.play("hurt.wav",sfx,0.3)
	   			Jugador1:setVidas(p2Vidas)
	   		end
	   	elseif key == "r" then
	   		resetea()
	   	end

	elseif gamestate == "menu" then
		if key == " " then
	   		gamestate = "pelea"
	   	end
	elseif gamestate == "GameOver" then
		if key == " " then
	   		love.event.push("quit")
	   	end
	end
end

function checaVidas(p1Vidas,p2Vidas) -- Pregunta si alguno de los dos jugadores esta muerto
	if p1Vidas == 0 or p2Vidas == 0 then
		if p1Vidas == 0 then
			ganador = "p2"
			gamestate = "GameOver"
		elseif p2Vidas == 0 then
			ganador = "p1"
			gamestate = "GameOver"
		end
	end
end

function resetea()  -- Reinicia los acumuladores para el siguente round
	p1Counter = 0;
	p2Counter = 0;
end

function gameOver(ganador) -- Anuncia el ganador del juego
end

function contabiliza (p1C,p2C) -- Anuncia el ganador de la ronda}
	if p1C > p2C then
		return string.format ("ganaP1")
	elseif p2C > p1C then
		return string.format ("ganaP2")
	elseif p1C == p2C then
		return string.format ("empate")
	end
end

function dibujaGUI()
	love.graphics.setFont(font)
	love.graphics.print ("Button Bashers Turbo Alpha",10,10)
	pelea = true
	love.graphics.setFont(contador,30)
	love.graphics.print (p1Counter,80,430)
	love.graphics.draw(lifebar[p1Vidas],10,40)
	love.graphics.print (p2Counter,550,430)
	love.graphics.draw(lifebar[p2Vidas],550,40)
	love.graphics.setFont(font)
end

function peleense()
	checaVidas(p1Vidas,p2Vidas)
	resultado = contabiliza(p1Counter,p2Counter)
	Timer.add(1, function() love.graphics.print (resultado,220,130) end)



end