--Button Bashers
--Version 0.1
--Hecho para clase de Programacion Avanzada
--Hecho por: José G, Ulises y Hector
--Librerias utilizadas: STI, HUMP (Class y Timer), TEsound




--Seccion para cargar las librerias requeridas------

local sti = require "STI" --La libreria STI (Simple Tile Loader) ayuda a dibujar el mapa de fondo
Class = require "class"  --La libreria Class de HUMP ayuda a obtener un acercamiento a objetos en el programa
Timer  = require "timer"  -- La libreria Timer de HUMP ayuda a realizar funciones de manera cronometrada
require "TEsound"  		  --La libreria TESound ayuda a manejar la musica/sfx de manera sencilla

-----------------------------------------------------

---Seccion que carga todos los recursos que va a utilizar el programa-------
function love.load()


    local scaleX = 1
    local scaleY = 1

    lifebar = {}
    lifebar[1] = love.graphics.newImage ("life1.png")
    lifebar[2] = love.graphics.newImage ("life2.png")
    lifebar[3] = love.graphics.newImage ("life3.png")

    arnulfo = {}
    arnulfo[1] = love.graphics.newImage ("j1.png")
    arnulfo[2] = love.graphics.newImage ("j1d.png")



	--mapa = sti.new("buttonBashers")
	p1Counter = 0
	p2Counter = 0
	local p1Vidas = 0
	local p2Vidas = 0
	tiempo = 5
	local debug = 0

	logo = love.graphics.newImage ("logo.png")
	bgm = love.audio.newSource("bgm.mp3")
	--hit = love.audio.newSource("hit.wav",static)
	hurt = love.audio.newSource("hurt.wav",static)
	mapa = love.graphics.newImage("mapa.png")


	gamestate = "menu" -- Menu, Pelea, GameOver (Con ganador)



	font = love.graphics.newImageFont("font.png",
	" abcdefghijklmnopqrstuvwxyz" ..
	"ABCDEFGHIJKLMNOPQRSTUVWXYZ0" ..
	"123456789.,!?-+/():;%&`'*#=[]\"")

	contador = love.graphics.newFont("Oswald-Regular.ttf",30)



	love.graphics.setFont(font)
	love.graphics.setColor(255,255,255)
	love.graphics.setBackgroundColor(255,255,255)

	Luchador  = Class{                            --Clase que define a los jugadores
		init = function(self,playerNumber,vidas,counter)  --Constructor
			self.playerNumber = playerNumber
			self.vidas = vidas
			self.counter = counter
		end;
		--funciones

		stats = function(self)
			if self.vidas > 0 then
				return string.format("Hola, soy el jugador #%.02f, y actualmente tengo %.02f vidas.",self.playerNumber,self.vidas)
			elseif self.vidas == 0 then
				return string.format("Hola, soy el jugador #%.02f, y actualmente estoy muerto!",self.playerNumber)
			end
		end;

		setVidas = function(self,vidas)
			self.vidas = vidas
		end;

		getVidas = function(self)
			return  self.vidas
		end;

		getCounter = function (self)
			return self.Counter 
		end;

		setCounter = function (self,counter)
			self.counter = counter 
		end;

	}

	Jugador1=Luchador(1,3,0)
	Jugador2=Luchador(2,3,0)

end
---------------------------------------------------------------------------------------------

----Funcion que nos dice que va a pasar cuando se cambie de frame--------------------
function love.update(dt)
	if gamestate == "menu" then
	end
	if gamestate == "pelea" then
		checaVidas(Jugador1:getVidas(),Jugador2:getVidas())

		if pelea == true then
			love.keypressed()
		end
	end

	if gamestate == "gameOver" then
		love.keypressed()
	end



	Timer.update(dt)  --Funcion necesaria para que todas las funciones que usen Timer se ejecuten
	--mapa:update(dt)   --Funcion para dibujar el mapa en cada cuadro
	TEsound.cleanup() --Funcion para que TEsound funcione adecuadamente

end
--------------------------------------------------------------------------------------------------


function love.draw()
	if debug ~= 0 then
		love.graphics.print ("Button Bashers Turbo Alpha",10,10)
		love.graphics.print (gamestate,500,10)
		love.graphics.print (Jugador1:getVidas(),10,100)
		love.graphics.print (Jugador2:getVidas(),10,120)
		love.graphics.print (tiempo,10,140)

	end
	
	if gamestate == "pelea" then
		bgm:play()
		love.graphics.setBackgroundColor(0,0,0)
		--love.graphics.draw(mapa,0,0)
		--mapa:draw(scaleX,scaleY)
		love.graphics.setFont(font)
		pelea = true
		love.graphics.setFont(contador,30)
		love.graphics.print (p1Counter,80,430)
		if Jugador1:getVidas() > 0 then
			love.graphics.draw(lifebar[Jugador1:getVidas()],10,40)
		end
		love.graphics.print (p2Counter,550,430)
		if Jugador2:getVidas() > 0 then
			love.graphics.draw(lifebar[Jugador2:getVidas()],550,40)
		end
		love.graphics.setFont(font)
		love.graphics.print ("Jugador 1",30,70)
		love.graphics.print ("Jugador 2",480,70)
		Timer.add(1, function() gamestate = "calcula" end)
	
	elseif gamestate == "menu" then
		love.graphics.setBackgroundColor(255,255,255)
		love.graphics.setFont(font)	
		love.graphics.draw(logo,120,0,0,1,1)
		love.graphics.print("Objetivo del juego:",205,430)
		love.graphics.print("Apachurra tu boton asignado (Z,M) y SOBREVIVE!",60,450)
		love.graphics.print("¡Apachurra ESPACIO para INICIAR!",155,370)

	
	elseif gamestate == "GameOver" then
		--mapa:draw(scaleX,scaleY)
		love.graphics.setBackgroundColor(2,2,2)
		love.graphics.setFont(contador,30)
		love.graphics.print ("GAME OVER",260,80)
		love.graphics.print ("Ganador: ",220,130)
		love.graphics.print (ganador,350,130)
		love.graphics.print ("[ESPACIO] Regresar al menu",10,440)
		love.graphics.print ("[Q] Salir",530,440)

	elseif gamestate == "calcula" then
		Timer.clear()
		--mapa:draw(scaleX,scaleY)
		love.graphics.setFont(font)
		love.graphics.setFont(contador,30)
		love.graphics.print (p1Counter,80,430)
		if Jugador1:getVidas() > 0 then
			love.graphics.draw(lifebar[Jugador1:getVidas()],10,40)
		end
		love.graphics.print (p2Counter,550,430)
		if Jugador2:getVidas() > 0 then
			love.graphics.draw(lifebar[Jugador2:getVidas()],550,40)
		end
		love.graphics.setFont(font)
		love.graphics.print ("Jugador 1",30,70)
		love.graphics.print ("Jugador 2",480,70)
		resultados = contabiliza(p1Counter,p2Counter)
		love.graphics.print (resultados,400,430)


	end
end




------FUNCIONES DEL PROGRAMA-------------




function love.keypressed(key) -- Funcion que determina que tecla esta presionada al  momento
	if key == "0" then
		if debug == 0 then
			debug = 1
		else
			debug = 0
		end
	end


	if gamestate == "pelea"  then						--Teclas a ejecutar en el gamestate "pelea"


	   	if key == "z" then                                    --Boton asignado al J1 para "Bashear"
	    	p1Counter = p1Counter + 1
	    	--TEsound.play("hit.wav",sfx,0.3)
	    	--Timer.add(1, function() prueba:play() end)

	   elseif key == "m" then								  --Boton asignado al J2 para "Bashear"
	   		p2Counter = p2Counter + 1
	   		--TEsound.play("hit.wav",sfx,0.3)

	   elseif key == "o" then							      --(DEBUG) Boton que quita una vida a P1
	   		if Jugador1:getVidas() > 0 then
	   			quita1 = Jugador1:getVidas()
	   			quita1 = quita1 - 1
	   			Jugador1:setVidas(quita1)
	   			TEsound.play("hurt.wav",sfx,0.3)
	   		end
	   		resetea()

	   elseif key == "p" then								  --(DEBUG) Boton que quita una vida a P2
	   		if Jugador2:getVidas() > 0 then
	   			quita2 = Jugador2:getVidas()
	   			quita2 = quita2 - 1
	   			Jugador2:setVidas(quita2)
	   			TEsound.play("hurt.wav",sfx,0.3)
	   		end
	   		resetea()

	   	elseif key == "r" then								--(DEBUG) Boton que reinicia los contadores de ambos jugadores
	   		resetea()

	   	else if key == "c" then								--(DEBUG) Boton que contabiliza
	   		resultado = contabiliza(p1Counter,p2Counter)
	   		love.graphics.print(resultado,250,250)
	   		resetea()
	   	end
	end
	elseif gamestate == "menu" then
		bgm:stop()
		if key == " " then
	   		gamestate = "pelea"
	   	elseif key == "q" then
	   		love.event.push("quit")
	   	end

	elseif gamestate == "GameOver" then

		if key == " " then
	   		reloadGame()

	   	elseif key == "q" then
	   		love.event.push("quit")
	   	end
	elseif gamestate "calcula" then

	end
end

function checaVidas(p1Vidas,p2Vidas) -- Pregunta si alguno de los dos jugadores esta muerto
	if p1Vidas <= 0 or p2Vidas <= 0 then
		if p1Vidas <= 0 then
			ganador = "p2"
			gamestate = "GameOver"
		elseif p2Vidas <= 0 then
			ganador = "p1"
			gamestate = "GameOver"
		end
	end
end

function resetea()  -- Reinicia los acumuladores para el siguente round
	p1Counter = 0;
	p2Counter = 0;
	contador = 5;
end


function reloadGame() --Regresa al juego a sus valores por defecto para jugar de nuevo!
	p1Counter = 0;
	p2Counter = 0;
	Jugador1:setVidas(3)
	Jugador2:setVidas(3)
	gamestate = "menu"
end



function contabiliza (p1Counter,p2Counter) -- Anuncia el ganador de la ronda

	if p1Counter > p2Counter then
		p2Vidas = Jugador2:getVidas()
		p2Vidas = p2Vidas - 1
		Jugador2:setVidas(p2Vidas)
		TEsound.play("hurt.wav",sfx,0.6)
		return string.format ("ganaP1")

	elseif p2Counter > p1Counter then
		p1Vidas = Jugador1:getVidas()
		p1Vidas = p1Vidas - 1
		Jugador1:setVidas(p1Vidas)
		TEsound.play("hurt.wav",sfx,0.6)
		return string.format ("ganaP2")

	elseif p1Counter == p2Counter then
		return string.format ("empate")
	end
	Timer.add(2, function() gamestate = "pelea" end)
end

function dibujaGUI()
end
